
var xload = new XLoadClient('experimental');
var binWasAdded = false;
var itemWasAdded = false;
var sequenceIsOk = true;
var requestBins, requestItems, requestOptions, responseData;

function setInputsEnabled(enabled) {
    $('input[name="binInput"]').prop('disabled', enabled ? false : 'disabled');
    $('input[name="itemInput"]').prop('disabled', enabled ? false : 'disabled');
    $('#scenario-select').prop('disabled', enabled ? false : 'disabled');    
    $('.btn').prop('disabled', enabled ? false : 'disabled');
    $('.input-group').prop('disabled', enabled ? false : 'disabled');
    $('.btn-group').prop('disabled', enabled ? false : 'disabled');
    if(enabled) {
        $('label[name="itemInput"]').removeClass("disabled");
        $('label[name="layout_focus"]').removeClass("disabled");
        
    } else {
        $('label[name="itemInput"]').addClass("disabled");
        $('label[name="layout_focus"]').addClass("disabled");
    }
}

function normalizeId(id) {
    return id.replace(/\s/g, '');
}

function addSequenceStop() {
    requestOptions.unloadingSequence.push({"itemsToUnload":[]});
    redrawSequencingOptions();
}

function removeSequenceStop() {
    requestOptions.unloadingSequence.pop();
    redrawSequencingOptions();
    packBins();
}

function onChangeNumberOfItemsToUnload(sequenceIdx, itemId) {
    if (sequenceIdx >= requestOptions.unloadingSequence.length) return;
    
    var numberOfItems = parseInt($('#sequenceItem-'+ sequenceIdx +'-' + normalizeId(itemId)).val());
    
    var found = false;
    for (var i=0; i<requestOptions.unloadingSequence[sequenceIdx].itemsToUnload.length; i++) {
        if (requestOptions.unloadingSequence[sequenceIdx].itemsToUnload[i].itemTypeId === itemId) {
            
            if (numberOfItems === 0) {
                requestOptions.unloadingSequence[sequenceIdx].itemsToUnload.splice(i,1);
            } else {
                requestOptions.unloadingSequence[sequenceIdx].itemsToUnload[i].numberOfItems = numberOfItems;
            }
            found = true;
        }
    }
    if (!found) {
        requestOptions.unloadingSequence[sequenceIdx].itemsToUnload.push({"itemTypeId": itemId, "numberOfItems": numberOfItems});
    }
    redrawSequencingOptions();
    packBins();
}

function redrawSequencingOptions() {
    var divOptions = $('#sequencing-constraints-container');
    divOptions.empty();
    
    var content ='<div class="panel panel-default"><div class="panel-heading"><h4 class="panel-title"><a data-toggle="collapse" href="#collapsible-sequencing-constraints">Sequencing constraints</a></h4></div>\
                  <div class="panel-group" id="sequencing-constraints">';
    
    content += '<div id="collapsible-sequencing-constraints" class="panel-collapse collapse' + (requestOptions.unloadingSequence.length ? "in" : "") + '">\
                <div class="panel-body">';

    var totalNumberOfItems = [];

    // header
    content += '<table style="width:100%;text-align:center"><tr><th style="text-align:left;width:50px">#Stop</th>';
    for (var i = 0; i < requestItems.length; i++) {
        totalNumberOfItems.push(0);
        content += '<th style="text-align:center;">'+ requestItems[i].id +'</th>';
    }
    content += '</tr>';
    
    // real content
    for(var i = 0; i < requestOptions.unloadingSequence.length; i++) {
        var stopIdx = i+1;
        var color = defaultBorderColors()[(stopIdx - 1) % defaultBorderColors().length];
        
        content += '<tr><td style="text-align:left"><span style="margin-right: 5px;color:#'+ color +'"><i class="fa fa-cube"></i></span>Stop ' + stopIdx + '</td>';
        for (var j = 0; j < requestItems.length; j++) {
            var numberOfItems = 0;
            // search for requestItems[j].id
            for (var k = 0; k < requestOptions.unloadingSequence[i].itemsToUnload.length; k++) {
                if (requestOptions.unloadingSequence[i].itemsToUnload[k].itemTypeId === requestItems[j].id) {
                    numberOfItems = requestOptions.unloadingSequence[i].itemsToUnload[k].numberOfItems;
                    break;
                }
            }
            content += '<td><input name="unloadSequence" id="sequenceItem-'+ i +'-'+ normalizeId(requestItems[j].id) +'" class="form-control" min="0" type="number" value="'+ numberOfItems +'" onChange="onChangeNumberOfItemsToUnload('+ i +',\''+ requestItems[j].id +'\')"></td>';
            totalNumberOfItems[j] = parseInt(totalNumberOfItems[j]) + parseInt(numberOfItems);
        }
        content += '</tr>';
    }
    
    // add total line
    sequenceIsOk = true;
    content += '<tr><th>Total</th>';
    for (var i = 0; i < totalNumberOfItems.length; i++) {
        content += '<td>'+ totalNumberOfItems[i] +' / '+ requestItems[i].numberOfItems +'</td>';
        
        sequenceIsOk &= (requestOptions.unloadingSequence.length == 0) || (totalNumberOfItems[i] == requestItems[i].numberOfItems);
    }
    content += '</tr>';
    
    content += '</table>';
    
    // Add button
    content += '<div><button type="button" style="margin-top:5px; height:28px; text-align:left; font-family:Arial; font-size:12px" class="btn panel-default" id="add-stop" onclick="addSequenceStop()"><i class="fa fa-plus" ></i>  Add new stop</button>\
    <button type="button" style="margin-top:5px; height:28px; text-align:right; font-family:Arial; font-size:12px" class="btn panel-default" id="add-stop" onclick="removeSequenceStop()">Remove last stop <i class="fa fa-minus" ></i></button></div>';
    
    content += '</div></div></div></div>';

    divOptions.append(content);
}

function applyStackingRestriction(bottomItemId, topItemId, restrict) {
    if (restrict) {
        // set a restriction between bottomItemId and topItemId
        let found = false;
        for (var i = 0; i < requestOptions.stackingOptions.stackingRestrictions.length; i++) {
            if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeId === bottomItemId) {
                requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.push(topItemId);
                found = true;
                break;
            }
        }
        if (!found) {
            requestOptions.stackingOptions.stackingRestrictions.push({
                "itemTypeId": bottomItemId,
                "restrictionType": "PROHIBITED",
                "itemTypeIds": [topItemId]
            });
        }
    } else {
        // remove all restrictions between bottomItemId and topItemId
        for (var i = 0; i < requestOptions.stackingOptions.stackingRestrictions.length; i++) {
            if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeId === bottomItemId) {
                for (var j = 0; j < requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.length; j++) {
                    if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds[j] === topItemId) {
                        requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.splice(j, 1);
                        j--;
                    }
                }
                if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.length == 0) {
                    requestOptions.stackingOptions.stackingRestrictions.splice(i, 1);
                    i--;
                }
            }
        }
    }
        
    redrawStackingOptions();
    packBins();
}

function redrawStackingOptions() {
    var divOptions = $('#stacking-constraints-container');
    divOptions.empty();
    
    var content = '<div class="panel panel-default"><div class="panel-heading"><h4 class="panel-title"><a data-toggle="collapse" href="#collapsible-stacking-constraints">Stacking constraints</a></h4></div>\
                   <div class="panel-group" id="stacking-constraints">';
    
    content += '<div id="collapsible-stacking-constraints" class="panel-collapse collapse' + (requestOptions.stackingOptions.stackingRestrictions.length ? "in" : "") + '">\
                <div class="panel-body">';
    
    // header
    content += '<table class="table" style="width:100%;text-align:center"><thead><tr><th style="text-align:center"><sub>below</sub>\\<sup>above</sup></th>';
    for (var i = 0; i < requestItems.length; i++) {
        content += '<th style="text-align:center">'+ requestItems[i].id +'</th>';
    }
    content += '</thead></tr>';
    
    // content
    for (var row = 0; row < requestItems.length; row++) {
        content += '<tr><th style="text-align:left">'+ requestItems[row].id +'</th>';
        for (var col = 0; col < requestItems.length; col++) {
            var compatibility = true;
            for (var i = 0; i < requestOptions.stackingOptions.stackingRestrictions.length; i++) {
                if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeId === requestItems[row].id) {
                    if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "ALL_PROHIBITED") {
                        compatibility = false;
                        break;
                    } else if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "PROHIBITED") {
                        for (var j = 0; j < requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.length; j++) {
                            if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds[j] === requestItems[col].id) {
                                compatibility = false;
                                break;
                            }
                        }
                    } else if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "ALLOWED") {
                        // Type ALLOWED is not handled !
                    }
                }
            }
            content += '<td>' + (compatibility ? '<i class="fa fa-check" aria-hidden="true" style="color:green;cursor:pointer" onClick="applyStackingRestriction(\''+ requestItems[row].id +'\',\''+ requestItems[col].id +'\', true)"></i>' : '<i class="fa fa-ban" aria-hidden="true" style="color:red;cursor:pointer" onClick="applyStackingRestriction(\''+ requestItems[row].id +'\',\''+ requestItems[col].id +'\', false)"></i>') + '</td>';
        }
        content += '</tr>';
    }
    
    content += '</table>';
    content += '</div></div></div></div>';
    
    divOptions.append(content);
}

function redrawOptions(normalizeRequest) {
    if (requestItems.length == 0) {
        requestOptions.unloadingSequence = [];
        requestOptions.stackingOptions.stackingRestrictions = [];
    } else if (normalizeRequest) {
        // unloadingSequence: remove unknown item
        for(var i = 0; i < requestOptions.unloadingSequence.length; i++) {
            for (var j = 0; j < requestOptions.unloadingSequence[i].itemsToUnload.length; j++) {
                let found = false;
                for (var k = 0; k < requestItems.length && !found.length; k++) {
                    found |= requestOptions.unloadingSequence[i].itemsToUnload[j].itemTypeId === requestItems[k].id;
                }
                if (!found) {
                    requestOptions.unloadingSequence[i].itemsToUnload.splice(j,1);
                    j--;
                }
            }
        }
        
        // stackingRestrictions:
        //   - change ALL_PROHIBITED into PROHIBITED
        //   - remove unknown item
        
        for (var i = 0; i < requestOptions.stackingOptions.stackingRestrictions.length; i++) {
            let found = false;
            for (var k = 0; k < requestItems.length; k++) {
                if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeId === requestItems[k].id) {
                    found = true;
                    break;
                }
            }
            if (!found) {
                requestOptions.stackingOptions.stackingRestrictions.splice(i, 1);
                i--;
            } else {
                if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "ALL_PROHIBITED") {
                    requestOptions.stackingOptions.stackingRestrictions[i].restrictionType = "PROHIBITED";
                    requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds = [];
                    for (var k = 0; k < requestItems.length; k++) {
                        requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.push(requestItems[k].id);
                    }
                } else if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "PROHIBITED") {
                    for (var j = 0; j < requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.length; j++) {
                        let found = false;
                        for (var k = 0; k < requestItems.length; k++) {
                            if (requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds[j] === requestItems[k].id) {
                                found = true;
                                break;
                            }
                        }
                        if (!found) {
                            requestOptions.stackingOptions.stackingRestrictions[i].itemTypeIds.splice(j, 1);
                            j--;
                        }
                    }
                } else if (requestOptions.stackingOptions.stackingRestrictions[i].restrictionType === "ALLOWED") {
                    // Type ALLOWED is not handled !
                }
            }
        }
    }
    
    redrawSequencingOptions();
    redrawStackingOptions();
}

function redrawBinList() {
    var binList = $('#bin-list');
    binList.empty();
    for(var i = 0; i < requestBins.length; i++) {
       addBinMarkupToList(requestBins[i], i);
    }
    var addButton = '<button type="button" style="margin-top:5px; height:37px; text-align:left; font-family:Arial; font-size:16px" class="btn panel-default btn-block" id="add-bin" onclick="addBin()"><i class="fa fa-plus" ></i>  Add new bin type</button>';
    binList.append(addButton); 
}

function addBinMarkupToList(bin, index) {
    var openedPanelIndex = binWasAdded ? requestBins.length - 1 : 0;
    var binId = normalizeId(bin.id);
    
    var content = '<div class="panel panel-default"><div class="panel-heading"><h4 class="panel-title"><a data-toggle="collapse" data-parent="#bin-list" href="#collapsible-item-bin-'+binId+'">' + bin.id + '</a></h4></div>\
            <div id="collapsible-item-bin-'+binId+'" class="panel-collapse collapse '+ (index == openedPanelIndex ? "in" : "") +'"><div class="panel-body">\
            <table><tr><td width="200px">Quantity:</td><td><input name="binInput" type="number" onchange="onBinValueChange(\''+bin.id+'\')" class="form-control" id="number-of-bins-'+binId+'" min="0" value="'+ (bin.numberOfBins) +'"></td></tr>\
            <tr><td width="200px">Max. Weight:</td>\
            <td><div class="input-group"><input name="binInput" type="number" step="100" class="form-control" onchange="onBinValueChange(\''+bin.id+'\')" id="max-weight-'+binId+'" min="0" value="'+ (bin.maximumWeightCapacity) +'" aria-describedby="max-weight-'+binId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="max-weight-'+binId+'-addon">kg</span></div></td></tr>\
            <tr><td width="200px">Width (X):</td>\
            <td><div class="input-group"><input name="binInput" type="number" step="10" class="form-control" onchange="onBinValueChange(\''+bin.id+'\')" id="width-'+binId+'" min="0" value="'+ (bin.dimensions.x) +'" aria-describedby="x-'+binId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="x-'+binId+'-addon">cm</span></div></td></tr>\
            <tr><td width="200px">Height (Y):</td>\
            <td><div class="input-group"><input name="binInput" type="number" step="10" class="form-control" onchange="onBinValueChange(\''+bin.id+'\')" id="height-'+binId+'" min="0" value="'+ (bin.dimensions.y) +'" aria-describedby="y-'+binId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="y-'+binId+'-addon">cm</span></div></td></tr>\
            <tr><td width="200px">Length (Z):</td>\
            <td><div class="input-group"><input name="binInput" type="number" step="10" class="form-control" onchange="onBinValueChange(\''+bin.id+'\')" id="length-'+binId+'" min="0" value="'+ (bin.dimensions.z) +'" aria-describedby="z-'+binId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="z-'+binId+'-addon">cm</span></div></td></tr>\
            </table></div></div></div>';        
    
    $('#bin-list').append(content);
}

function onBinValueChange(identifier) {
    var bin = getBinById(identifier);
    var binId = normalizeId(bin.id);
    bin.numberOfBins = parseInt($('#number-of-bins-' + binId).val());
    bin.maximumWeightCapacity = parseInt($('#max-weight-' + binId).val());
    bin.dimensions.x = parseInt($('#width-' + binId).val());
    bin.dimensions.y = parseInt($('#height-' + binId).val());
    bin.dimensions.z = parseInt($('#length-' + binId).val());

    packBins();
}

function getBinById(binId) {
    for(var i = 0; i < requestBins.length; i++) {
       if(requestBins[i].id == binId)
           return requestBins[i];
    }
    return null;
}

function addBin() {
    binWasAdded = true;
    index = requestBins.length + 1;
    bin = {
      "id": "Bin Type " + index,
      "numberOfBins": 1,
      "dimensions": {
        "x": 250,
        "y": 250,
        "z": 1360
      },
      "maximumWeightCapacity": 25000
    };
    requestBins.push(bin);
    redrawBinList();
    packBins();
}

function redrawItemList() {
    var itemList = $('#item-list');
    itemList.empty();
    for(var i = 0; i < requestItems.length; i++) {
       addItemMarkupToList(requestItems[i], i);
    }
    var addButton = '<button type="button" style="margin-top:5px; height:37px; text-align:left; font-family:Arial; font-size:16px" class="btn panel-default btn-block" id="add-item" onclick="addItem()"><i class="fa fa-plus" ></i>  Add new item type</button>';
    itemList.append(addButton);  
}

function addItemMarkupToList(item, index) {
    var openedPanelIndex = itemWasAdded ? requestItems.length - 1 : 0;
    var itemId = normalizeId(item.id);
    
    var content = '<div class="panel panel-default"><div class="panel-heading"><h4 class="panel-title"><a data-toggle="collapse" data-parent="#item-list" href="#collapsible-item-'+itemId+'">' + item.id + '</a></h4></div>\
            <div id="collapsible-item-'+itemId+'" class="panel-collapse collapse '+ (index == openedPanelIndex ? "in" : "") +'"><div class="panel-body">\
            <table><tr><td width="200px">Quantity:</td>\
            <td><input type="number" name="itemInput" step="1" class="form-control" onchange="onItemValueChange(\''+item.id+'\')" id="number-of-items-'+itemId+'" min="0" max="10000" value="'+ (item.numberOfItems) +'"></td></tr>\
            <tr><td width="200px">Weight:</td>\
            <td><div class="input-group"><input name="itemInput" type="number" step="10" class="form-control" onchange="onItemValueChange(\''+item.id+'\')" id="weight-'+itemId+'" min="0" value="'+ (item.weight) +'" aria-describedby="weight-'+itemId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="weight-'+itemId+'-addon">kg</span></div></td></tr>\
            <tr><td width="200px">Width (X):</td>\
            <td><div class="input-group"><input name="itemInput" type="number" step="10" class="form-control" onchange="onItemValueChange(\''+item.id+'\')" id="width-'+itemId+'" min="0" value="'+ (item.dimensions.x) +'" aria-describedby="x-'+itemId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="x-'+itemId+'-addon">cm</span></div></td></tr>\
            <tr><td width="200px">Height (Y):</td>\
            <td><div class="input-group"><input name="itemInput" type="number" step="10" class="form-control" onchange="onItemValueChange(\''+item.id+'\')" id="height-'+itemId+'" min="0" value="'+ (item.dimensions.y) +'" aria-describedby="y-'+itemId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="y-'+itemId+'-addon">cm</span></div></td></tr>\
            <tr><td width="200px">Length (Z):</td>\
            <td><div class="input-group"><input name="itemInput" type="number" step="10" class="form-control" onchange="onItemValueChange(\''+item.id+'\')" id="length-'+itemId+'" min="0" value="'+ (item.dimensions.z) +'" aria-describedby="z-'+itemId+'-addon">\
            <span class="input-group-addon" style="width:45px" id="z-'+itemId+'-addon">cm</span></div></td></tr></table><div>\
            <button type="button" name="itemInput" class="btn btn-default pull-right" style="margin-top:10px" onclick="removeItem(\''+item.id+'\')" data-dismiss="modal"><span class="glyphicon glyphicon-trash"></span> Remove</button>\
            <div class="btn-group" style="padding-top:10px" data-toggle="buttons">\
                <label name="itemInput" class="btn btn-default ' + (isTiltable(item.id) ? "active" : "") + '"><input id="tiltable-'+itemId+'" name="itemInput" type="checkbox" name="itemInput" onchange="onItemValueChange(\''+item.id+'\')" ' + (isTiltable(item.id) ? "checked" : "") + ' autocomplete="off">Tiltable</label>\
                <label name="itemInput" class="btn btn-default ' + (isStackable(item.id) ? "active" : "") + '"><input id="stackable-'+itemId+'" name="itemInput" type="checkbox" name="itemInput" onchange="onItemValueChange(\''+item.id+'\')" ' + (isStackable(item.id) ? "checked" : "") + ' autocomplete="off">Stackable</label>\
            </div>\
            <div></div></div></div>';        
    
    $('#item-list').append(content);    
}

function isTiltable(itemId) {
    var item = getItemById(itemId);    
    return (jQuery.isEmptyObject(item.allowedOrientations) );
}

function isStackable(itemId) {
    var item = getItemById(itemId);    
    return (jQuery.isEmptyObject(item.maximumSurfaceLoads) );
}

function onItemValueChange(identifier) {
    var item = getItemById(identifier);
    var itemId = normalizeId(item.id);
    item.numberOfItems = parseInt($('#number-of-items-' + itemId).val());
    item.weight = parseInt($('#weight-' + itemId).val());
    item.dimensions.x = parseInt($('#width-' + itemId).val());
    item.dimensions.y = parseInt($('#height-' + itemId).val());
    item.dimensions.z = parseInt($('#length-' + itemId).val());
    
    if (!$("#tiltable-" +itemId).is(':checked')) {
        item.allowedOrientations = {
            // If we may not tilt the packet we only allow original or y orientation
            original: true,
            x: false,
            y: true,
            z: false,
            xz: false,
            yz: false
        };
    } else {
        delete item.allowedOrientations;
    }
    
    if (!$("#stackable-"+itemId).is(':checked')) {
        item.maximumSurfaceLoads = {
            // If not stackable no load is allowed on any axis
            x: 0.0,
            y: 0.0,
            z: 0.0
        };
    } else {
        delete item.maximumSurfaceLoads;
    }
    
    redrawSequencingOptions();
    packBins();
}

function removeItem(identifier) {
    for(var i = 0; i < requestItems.length; i++) {
       if(requestItems[i].id == identifier)
           requestItems.splice(i, 1);
    }
    redrawItemList();
    redrawOptions(true);
    packBins();
}

function getItemById(itemId) {
    for(var i = 0; i < requestItems.length; i++) {
       if(requestItems[i].id == itemId)
           return requestItems[i];
    }
    return null;
}

function addItem() {
    itemWasAdded = true;
    var index = requestItems.length + 1;
    var item = {
          "id": "Item Type " + index,
          "numberOfItems": 10,
          "dimensions": {
            "x": 120,
            "y": 100,
            "z": 80
          },
          "weight": 50
        };
    requestItems.push(item);
    redrawItemList();
    redrawOptions(false);
    packBins();
}


function redrawLoadedList(loadedBins) {
    var loadedList = $('#loaded-list');
    loadedList.empty();
    for(var i = 0; i < loadedBins.length; i++) {
       addLoadedBinMarkupToList(loadedBins[i], i);              
    }  
    loadedList.on('show.bs.collapse', onDisplayedBinChange);
}

function addLoadedBinMarkupToList(bin, index) {
    var binId = normalizeId(bin.bin.label);
    binId = binId.replace(/[()]/g, '');
    var loadingMetersPercentage = ((bin.bin.loading_meters_used /  bin.bin.loading_meters_total) * 100).toFixed(1);
    var volumePercentage = ((bin.loaded_volume / bin.total_volume) * 100).toFixed(1);
    var weightPercentage = ((bin.loaded_weight / bin.bin.maxweight) * 100).toFixed(1);
    var content = '<div class="panel panel-default"><div class="panel-heading"><h4 class="panel-title"><a data-toggle="collapse" data-parent="#loaded-list" href="#collapsible-item-'+binId+'_'+index+'">' + bin.bin.label + '</a></h4></div>\
            <div id="collapsible-item-'+binId+'_'+index+'" class="panel-collapse collapse '+ (index == 0 ? "in" : "") +'"><div class="panel-body">\
            <table style="width:100%;"><tr><td style="width:125px">Loading Meters:</td><td style="text-align:right">'+ bin.bin.loading_meters_used.toLocaleString()+'</td><td> m</td>\
            <td style="width:10px">/</td><td style="text-align:right">'+ bin.bin.loading_meters_total.toLocaleString()+'</td><td> m</td>\
            <td style="width:30%;"><div class="progress" style="margin-bottom:5px"><div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="'+ loadingMetersPercentage +'" aria-valuemin="0" aria-valuemax="100" style="width:'+loadingMetersPercentage+'%;"><span>'+loadingMetersPercentage+'%</span></div></div></td></tr>\
            <tr><td>Loaded Volume:</td><td style="text-align:right">'+ bin.loaded_volume.toLocaleString()+'</td><td> m³</td>\
            <td>/</td><td style="text-align:right">'+ bin.total_volume.toLocaleString() +'</td><td> m³</td>\
            <td><div class="progress" style="margin-bottom:5px"><div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="'+ volumePercentage +'" aria-valuemin="0" aria-valuemax="100" style="width:'+volumePercentage+'%;"><span>'+volumePercentage+'%</span></div></div></td></tr>\
            <tr><td>Loaded Weight:</td><td style="text-align:right">'+ bin.loaded_weight.toLocaleString()+'</td><td> kg</td>\
            <td>/</td><td style="text-align:right"> '+ bin.bin.maxweight.toLocaleString() +'</td><td> kg</td>\
            <td><div class="progress" style="margin-bottom:5px"><div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="'+ weightPercentage +'" aria-valuemin="0" aria-valuemax="100" style="width:'+weightPercentage+'%;"><span>'+weightPercentage+'%</span></div></div></td></tr>\
            </table><div class="panel-group" style="margin-bottom:0px; margin-top:15px"><div class="panel panel-default"><div class="panel-heading">\
            <h4 class="panel-title"><a data-toggle="collapse" href="#collapse'+binId+'"><span class="badge pull-right">' + bin.loaded_items.toLocaleString() + '</span>Loaded Items</a></h4>\
            </div><div id="collapse'+binId+'" class="panel-collapse collapse">'+ getListOfLoadedItems(bin.accumulatedItems) +'</div></div></div></div></div></div>';        
    
    $('#loaded-list').append(content);
}

function getListOfLoadedItems(accumulatedItems) {
    var result = '<ul class="list-group" style="margin-bottom:0px">';
    
    $.each(accumulatedItems, function(x, item) {
        result += '<li class="list-group-item"><span class="badge">'+item.amount.toLocaleString()+'</span>'+item.label+'</li>';
    });
    
    result += '</ul>';
    return result;
}

function redrawOutput() {
    updateOutputTotals();
    redrawLoadedList(responseData.loaded_bins);
    redrawUnloadedList(responseData.offloaded_items, (responseData.total_number_items - responseData.total_loaded_items));
    if(responseData.loaded_bins[0]) {
        changeDisplayedBin(0, responseData.loaded_bins[0].bin.label);
    } else {
        $('#containers').html('<div style="text-align:center; position: relative; top: 30%;"><h3>No displayable result.</h3></div>');
    }
}

function updateOutputTotals() {
    $('#loaded-volume-summary').html(responseData.total_loaded_volume.toLocaleString());
    $('#total-loaded-volume-summary').html(responseData.total_volume_capacity.toLocaleString());
    var volumePercentage = ((responseData.total_loaded_volume / responseData.total_volume_capacity) * 100).toFixed(1);
    updateProgressbar('loaded-volume-progress', volumePercentage);
    
    $('#loaded-weight-summary').html(responseData.total_loaded_weight.toLocaleString());
    $('#total-loaded-weight-summary').html(responseData.total_weight_capacity.toLocaleString());
    var weightPercentage = ((responseData.total_loaded_weight / responseData.total_weight_capacity) * 100).toFixed(1);
    updateProgressbar('loaded-weight-progress', weightPercentage);
    
    $('#loaded-items-summary').html(responseData.total_loaded_items.toLocaleString());
    $('#total-loaded-items-summary').html(responseData.total_number_items.toLocaleString());
    var itemPercentage = ((responseData.total_loaded_items / responseData.total_number_items) * 100).toFixed(1);
    updateProgressbar('loaded-items-progress', itemPercentage);
    
}

function redrawUnloadedList(offloadedItems, numberOfUnloadedItems) {
    var unloadedItems = $('#unloadedItems-list');
    unloadedItems.empty();
    if(!offloadedItems || offloadedItems.length == 0) {
        return;
    }
    var content = '<div class="panel-group" style="margin-bottom:0px; margin-top:15px"><div class="panel panel-default">\
        <div class="panel-heading"><h4 class="panel-title">\
        <a data-toggle="collapse" href="#unloaded-list">Unloaded items</a><span class="badge pull-right">' + numberOfUnloadedItems + '</span>\
        </h4></div><div id="unloaded-list" class="panel-collapse collapse"><ul class="list-group" style="margin-bottom:0px">';
    $.each(offloadedItems, function(index, item) {
        content += '<li class="list-group-item"><span class="badge">'+(item.amount - item.loaded).toLocaleString()+'</span>'+item.label+'</li>';
    });
    
    content += '</ul></div></div></div>';
    unloadedItems.html(content);
    
}

function updateProgressbar(id, value) {
    $('#' + id).css('width', value+'%').attr('aria-valuenow', value).html('<span>'+value+'%</span>');
}

var get_layout_focus = function() {
    var focus_layered = $("#layout_focus_layered").is(':checked');
    if (focus_layered) return "BUILD_LAYERS";
    else return "REDUCE_LOADING_METERS";
};

function changeDisplayedBin(index, label) {
    $("#containers").empty();
    $("#displayed-bin-label").text(label);
    createBinGraph(index, responseData.loaded_bins[index], "#containers");
}

function onDisplayedBinChange(evt) {
    //console.log(evt);
    var identifier = evt.target.id;
    var delim = identifier.indexOf('_');
    if(delim == -1) {
        return;
    }
    var index = identifier.substr((delim + 1));
    var label = responseData.loaded_bins[index].bin.label;
    changeDisplayedBin(index, label);
}

////// Output functions
var convert_to_visualizer_input = function(request, response) {
    var loadedBins = []
    var binTypes = {};
    for (var i = 0; i < request.bins.length; ++i) {
        var bin = request.bins[i];
        binTypes[bin.id] = i;
        bin.nr = i;
    }
    
    var total_number_items = 0;
    var itemTypes = {};
    for (var i = 0; i < request.items.length; ++i) {
        var item = request.items[i];
        itemTypes[item.id] = i;
        item.nr = i;
        total_number_items += item.numberOfItems;
    }

    var totalItemsPerSequence = [];
    var hasUnloadingSequence = request.options.unloadingSequence && request.options.unloadingSequence.length > 0;
    if (hasUnloadingSequence) {
        for (var i = 0; i < request.options.unloadingSequence.length; i++) {
            totalItemsPerSequence.push(0);
            for (var j = 0; j < request.options.unloadingSequence[i].itemsToUnload.length; j++) {
                totalItemsPerSequence[i] += parseInt(request.options.unloadingSequence[i].itemsToUnload[j].numberOfItems);
            }
        }
    }
    
    if (response.packedBins) {       
        for (var bi = 0; bi < response.packedBins.length; ++bi) {
            var binData = {};
            var packedBin = response.packedBins[bi];
            var binType = request.bins[binTypes[packedBin.binTypeId]];

            binData["bin"] = {
                label : "Bin " + (bi + 1) + " (" + packedBin.binTypeId + ")",
                type: packedBin.binTypeId,
                x: 0, y : 0, z : 0,
                width: binType.dimensions.x,
                height: binType.dimensions.y,
                depth: binType.dimensions.z,
                loading_meters_total: binType.dimensions.z / 100,
                loading_meters_used: packedBin.loadingMeters,                
                maxweight: binType.maximumWeightCapacity
            };
            binData["items"] = [];
            binData["accumulatedItems"] = [];
            if (packedBin.packedItems) {
                for (var ii = 0; ii < packedBin.packedItems.length; ++ii) {
                    var item = packedBin.packedItems[ii];
                    var itemType = request.items[itemTypes[item.itemTypeId]];
                    
                    var seqNr = totalItemsPerSequence.length - 1;
                    if (totalItemsPerSequence.length > 0) {
                        totalItemsPerSequence[totalItemsPerSequence.length - 1] = totalItemsPerSequence[totalItemsPerSequence.length - 1] - 1;
                        if (totalItemsPerSequence[totalItemsPerSequence.length - 1]  == 0) {
                            totalItemsPerSequence.pop();
                        }
                    }
                    
                    var itemData = {
                        label : item["itemTypeId"],
                        nr : itemType.nr,
                        x : item.position.x,
                        y : item.position.y,
                        z : item.position.z,
                        width : item.dimensions.x,
                        height : item.dimensions.y,
                        depth : item.dimensions.z,
                        weight : itemType.weight,
                        sequenceNumber : seqNr
                    };

                    binData.items.push(itemData);
                }
                
                var accItems = {};
                for (var i = 0; i < binData.items.length; ++i) {
                    var d = binData.items[i];
                    if (accItems[d.nr]) accItems[d.nr].amount++;
                    else {
                        accItems[d.nr] = { "label": d.label, "width": d.width, "height": d.height, "depth": d.depth, "weight": d.weight, "amount": 1};
                    }
                }
                binData["accumulatedItems"] = $.map(accItems, function(value, index) {
                    return [value];
                });
                
            }
            loadedBins.push(binData);
        }
    }

    var offloadedItems = [];
    if (response.itemsNotPacked) {
        for (var i = 0; i < response.itemsNotPacked.length; ++i) {
            var itemNotPacked = response.itemsNotPacked[i];
            var initialItem = request.items[itemTypes[itemNotPacked.id]];
            var offloadedItem = {
                label: itemNotPacked.id,
                x: itemNotPacked.dimensions.x,
                y: itemNotPacked.dimensions.y,
                z: itemNotPacked.dimensions.z,
                weight: itemNotPacked.weight,
                amount: initialItem.numberOfItems,
                loaded: initialItem.numberOfItems - itemNotPacked.numberOfItems
            };
            offloadedItems.push(offloadedItem);
        }
    }
    
            
    var total_loaded_volume = 0;
    var total_volume_capacity = 0;
    var total_loaded_weight = 0;
    var total_loaded_items = 0;
    var total_weight_capacity = 0;
    
    for (var i = 0; i < loadedBins.length; i++) {
        var d = loadedBins[i];
        loadedBins[i].loaded_items = d.items.length;
        loadedBins[i].loaded_volume = 0;
        loadedBins[i].loaded_weight = 0;
        for (var j = 0; j < d.items.length; ++j) {
            var item = d.items[j];
            loadedBins[i].loaded_volume += item.width * item.height * item.depth;
            loadedBins[i].loaded_weight += item.weight;
        }        
        loadedBins[i].total_volume = (d.bin.width * d.bin.height * d.bin.depth);
        
        var label = d.label;
        if (label == undefined) {
            label = d.bin.type;
        }
        
        // convert to m³
        d.loaded_volume /= 1000000;
        d.total_volume /= 1000000;
        
        total_loaded_volume += d.loaded_volume;
        total_volume_capacity += d.total_volume;
        total_loaded_weight += d.loaded_weight;
        total_loaded_items += d.loaded_items;
        total_weight_capacity += d.bin.maxweight;        
    }   
        
    
    return {
        loaded_bins: loadedBins,
        offloaded_items: offloadedItems,
        total_loaded_volume: total_loaded_volume,
        total_volume_capacity: total_volume_capacity,
        total_loaded_weight: total_loaded_weight,
        total_weight_capacity: total_weight_capacity,
        total_loaded_items: total_loaded_items,
        total_number_items: total_number_items,
        
        hasUnloadingSequence: hasUnloadingSequence
    };
};

var mouse = {};
document.onmousemove = function(e) {
    mouse.x = e.clientX;
    mouse.y = e.clientY;
}

function createBinGraph(index, data, div) {
    $(div).append("<div id=\"pack" + index + "\" class=\"packwidget\"></div>");

    var items = mapItems(data.items, defaultMapping());
    var bins = mapBins([data.bin], binMapping());
    var packwidget = new PackWidget(bins, items, defaultOptions());
    packwidget.onItemOver = function(item) { 
        if (item) {
            highlightItem(item); 
            tooltip(mouse.x, mouse.y , item.dataItem.label, item); 
        } };
    packwidget.onItemOut = function(item) { 
        if (item) { 
            removeTooltip(item); 
            unhighlightItem(item); 
        } };
    packwidget.create($("#pack" + index).get(0));
}

function defaultMapping () {
    var colors = defaultColors();
    var borderColors = defaultBorderColors();
    return {
        "x_start": ["x"],
        "y_start": ["y"],
        "z_start": ["z"],
        "x_length": ["width"],
        "y_length": ["height"],
        "z_length": ["depth"],
        "color": function (item) {
            return colors[item.nr % colors.length];
        },
        "border_color": function (item) {
            if (item.sequenceNumber >= 0) return "0x" + borderColors[item.sequenceNumber % borderColors.length];
            return "0x000000";
        },
        "highlight_color": function (item) {
            if (item.sequenceNumber >= 0) return "0x" + borderColors[item.sequenceNumber % borderColors.length];
            return "0xFF0000";
        }
    };
}

function defaultColors () {
    return [
        "0xdf7126","0xd9a066","0xeec39a","0xfbf236",
        "0x99e550","0x6abe30","0x37946e","0x4b692f","0x524b24","0xe02f74","0x30a082",
        "0x639bff","0x5ffe4","0xcbfffc","0x9badb7","0x847eee","0x696aee",
        "0xee0000","0x76428a","0xac3232","0xd95763","0xd77bba","0x8f974a","0x8a6f30",
        "0x22f4f1","0x45283c","0x663931","0x8f563b"
    ];
}

function defaultBorderColors () {
    return [
        "6C3483","117A65","F1C40F","AF601A","6C3483","1E8449","B7950B","34495E"
    ];
}

function binMapping () {
    var colors = defaultColors();
    return {
        "x_start": ["x"],
        "y_start": ["y"],
        "z_start": ["z"],
        "x_length": ["width"],
        "y_length": ["height"],
        "z_length": ["depth"],
        "color": "0xff0000"
    };
}

function defaultOptions () {
    return {
        width: $(".binpicture").width(),
        height: $(".bintable").height(),
        backgroundColor: 0xeeeeee,
        cameraType: "perspective",
        horizontalRotation: true,
        verticalRotation: true,
        border: 40
    };
}

// send request with current data
function packBins() {
    if (!sequenceIsOk) {
        $('#containers').html('<div style="text-align:center; position: relative; top: 30%;"><h3>Sequencing constraints is not correct.</h3></div>');
        return;
    }
    
    
    //console.log("Starting to pack");
    $('#progress-spinner').css('display', 'block');
    setInputsEnabled(false);
    var request = getLoadRequest();
    //console.log("Request:");
    //console.log(request);
    responseData = null;
    
    resetLocalStorage();    
    saveRequestToLocalStorage("xload", "packBins", request);
    
    xload.packBins(request, function(request) {
        return function(result, error) {
            loadCallback(request, result, error);
        }
    }(request));
}

var getLoadRequest = function() {
    requestOptions.focus = $('input[name=layout_focus]:checked').val();
    return {
        "bins": copyBins(requestBins),
        "items": copyItems(requestItems),
        "options": requestOptions
    }
};

var loadCallback = function(request, result, error) {
    //console.log("Got result:");
    setInputsEnabled(true);
    $('#containers').empty();
    if (error) {
        console.log("Request failed");
        console.log(error); 
        $('#containers').html('<div style="text-align:center; position: relative; top: 30%;"><h3>No displayable result.</h3></div>');
        showError(error);
    } else {
        var data = convert_to_visualizer_input(request, result);
        responseData = data;
        
        redrawOutput();
        //console.log(result);
    }
    $('#progress-spinner').css('display', 'none');
};

function loadScenario(scenarioId) {    
    var scenario;
    if(scenarioId == null) {
        scenario = scenarios[$('#scenario-select').val()];
    } else {
        $('#scenario-select').val(scenarioId);
        scenario = scenarios[scenarioId];
    }    
    requestBins = copyBins(scenario.bins);
    requestItems = copyItems(scenario.items);
    requestOptions = copyOptions(scenario.options);
    
    setOptions(requestOptions);
        
    redrawBinList();
    redrawItemList();
    redrawOptions(true);
    packBins();
}

function setOptions(options) {
    var selected, other;
    if(options.focus == "BUILD_LAYERS") {
        selected = $('#layout_focus_layered');
        other = $('#layout_focus_reduced_loading_meters');
    } else {
        selected = $('#layout_focus_reduced_loading_meters');
        other = $('#layout_focus_layered');
    }    
    selected.prop("checked", true);    
    other.parent().removeClass('active');
    selected.parent().addClass('active'); 
}

function resetShowcase() {
    requestBins = [];
    requestItems = [];
    requestOptions = {};
    responseData = null;
    loadScenario(); 
}

function fillScenarioSelect() {
    var scenarioSelect = $('#scenario-select');
    var content = '';
    $.each( scenarios, function( key, value ) {
      content += '<option value="'+ key +'">'+ key +'</option>'
    }); 
    scenarioSelect.html(content);
}



// EVENTHANDLER
$('input[name="layout_focus"]').change( function() {packBins();});
$('#scenario-select').change(function() {loadScenario();});
$('#reset-btn').click( resetShowcase );

$('#load-csv-btn').click( function() {resetTemplate(); $("#loadDialog").modal('show'); });

var loadedScenarioCount = 1;
$('#load-scenario-btn').click( function() {
    var scenarioName = "importedScenario_" + loadedScenarioCount++;
    scenarios[scenarioName] = JSON.parse(JSON.stringify(scenarioTemplate));
    fillScenarioSelect();    
    loadScenario(scenarioName);
    resetTemplate();
    $('#loadDialog').modal('hide');
} );

// INIT
function initialize() {
    $('#wrapping-table').css('height', $(document).height());
    var calculatedHeight = $('#wrapping-table').height() - 60;
    $('.tab-content').css('height', calculatedHeight - 40);  
    $('.binpicture').css('height', calculatedHeight);   
    $('.packwidget').css('height', calculatedHeight);     
}

fillScenarioSelect();
loadScenario("default");

// UTILITY
function copyBins(source) {
    var result = [];
    for(var i = 0; i < source.length; i++) {
        var bin = source[i];
        result.push({            
          "id": bin.id,
          "numberOfBins": bin.numberOfBins,
          "dimensions": {
            "x": bin.dimensions.x,
            "y": bin.dimensions.y,
            "z": bin.dimensions.z
          },
          "maximumWeightCapacity": bin.maximumWeightCapacity
        });
    }
    return result;
}
function copyItems(source) {
    var result = [];
    for(var i = 0; i < source.length; i++) {
        var item = source[i];
        result.push({            
          "id": item.id,
          "numberOfItems": item.numberOfItems,
          "dimensions": {
            "x": item.dimensions.x,
            "y": item.dimensions.y,
            "z": item.dimensions.z
          },
          "weight": item.weight,
        });
        if (!jQuery.isEmptyObject(item.maximumSurfaceLoads)) {
            result[result.length - 1].maximumSurfaceLoads = item.maximumSurfaceLoads;
        }
        if (!jQuery.isEmptyObject(item.allowedOrientations)) {
            result[result.length - 1].allowedOrientations = item.allowedOrientations;
        }
    }
    return result;
}
function copyOptions(options) {    
    let result = (options)? JSON.parse(JSON.stringify(options)) : {};
    if (!result.focus) result.focus = "BUILD_LAYERS";
    if (!result.unloadingSequence) result.unloadingSequence = [];
    if (!result.stackingOptions) result.stackingOptions = {"stackingRestrictions":  []};
    return result;
}
