var scenarios = {    
    "default": {
        "bins": [{
            "id": "Truck",
            "numberOfBins": 1,
            "dimensions": {
                "x": 240,
                "y": 244,
                "z": 1360
            },
            "maximumWeightCapacity": 20000
        }],
        "items": [{
            "id": "Large Packets",
            "numberOfItems": 10,
            "dimensions": {
                "x": 120,
                "y": 80,
                "z": 180
            },
            "weight": 50,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        },
        {
            "id": "Small Packets",
            "numberOfItems": 5,
            "dimensions": {
                "x": 120,
                "y": 80,
                "z": 30
            },
            "weight": 70,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        },
        {
            "id": "Quadratic Boxes",
            "numberOfItems": 2,
            "dimensions": {
                "x": 200,
                "y": 200,
                "z": 200
            },
            "weight": 800,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                "x": 0,
                "y": 0,
                "z": 0
            }
        },
        {
            "id": "Large Boxes",
            "numberOfItems": 2,
            "dimensions": {
                "x": 200,
                "y": 240,
                "z": 110
            },
            "weight": 1500,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        }],
        "options": {
            "focus": "BUILD_LAYERS"
        }
    },

    "default Reduced": {
        "bins": [{
            "id": "Truck",
            "numberOfBins": 1,
            "dimensions": {
                "x": 240,
                "y": 244,
                "z": 1360
            },
            "maximumWeightCapacity": 20000
        }],
        "items": [{
            "id": "Large Packets",
            "numberOfItems": 10,
            "dimensions": {
                "x": 120,
                "y": 80,
                "z": 180
            },
            "weight": 50,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        },
        {
            "id": "Small Packets",
            "numberOfItems": 5,
            "dimensions": {
                "x": 120,
                "y": 80,
                "z": 30
            },
            "weight": 70,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        },
        {
            "id": "Quadratic Boxes",
            "numberOfItems": 2,
            "dimensions": {
                "x": 200,
                "y": 200,
                "z": 200
            },
            "weight": 800,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                "x": 0,
                "y": 0,
                "z": 0
            }
        },
        {
            "id": "Large Boxes",
            "numberOfItems": 2,
            "dimensions": {
                "x": 200,
                "y": 240,
                "z": 110
            },
            "weight": 1500,
            "allowedOrientations": {
                
            },
            "maximumSurfaceLoads": {
                
            }
        }],
        "options": {
            "focus": "REDUCE_LOADING_METERS"
        }
    },
    
    "minimal" : {
      "bins": [
        {
          "id": "Truck",
          "numberOfBins": 1,
          "dimensions": {
            "x": 250,
            "y": 250,
            "z": 1360
          },
          "maximumWeightCapacity": 25000
        }
      ],
      "items": [
        {
          "id": "Pallet",
          "allowedOrientations": {},
          "maximumSurfaceLoads": {},
          "numberOfItems": 10,
          "dimensions": {
            "x": 120,
            "y": 100,
            "z": 80
          },
          "weight": 50
        }
      ],
      "options": {
          "focus": "BUILD_LAYERS"
      }
    },
    
    "minimal reduced" : {
      "bins": [
        {
          "id": "Truck",
          "numberOfBins": 1,
          "dimensions": {
            "x": 250,
            "y": 250,
            "z": 1360
          },
          "maximumWeightCapacity": 25000
        }
      ],
      "items": [
        {
          "id": "Pallet",
          "allowedOrientations": {},
          "maximumSurfaceLoads": {},
          "numberOfItems": 10,
          "dimensions": {
            "x": 120,
            "y": 100,
            "z": 80
          },
          "weight": 50
        }
      ],
      "options": {
          "focus": "REDUCE_LOADING_METERS"
      }
    },
    
    "Sequencing" : {
      "bins": [
        {
          "id": "Truck",
          "numberOfBins": 1,
          "dimensions": {
            "x": 100,
            "y": 100,
            "z": 300
          },
          "maximumWeightCapacity": 25000
        }
      ],
      "items": [
        {
          "id": "Type 1",
          "numberOfItems": 6,
          "dimensions": {
            "x": 50,
            "y": 50,
            "z": 50
          },
          "weight": 50
        },
        {
          "id": "Type 2",
          "numberOfItems": 6,
          "dimensions": {
            "x": 50,
            "y": 50,
            "z": 50
          },
          "weight": 50
        },
        {
          "id": "Type 3",
          "numberOfItems": 6,
          "dimensions": {
            "x": 50,
            "y": 50,
            "z": 50
          },
          "weight": 50
        },
      ],
      "options": {
          "focus": "REDUCE_LOADING_METERS",
          "unloadingSequence": [
              { "itemsToUnload": [ {"itemTypeId": "Type 1", "numberOfItems": "2" }, {"itemTypeId": "Type 3", "numberOfItems": "3"}] },
              { "itemsToUnload": [ {"itemTypeId": "Type 2", "numberOfItems": "6" }] },
              { "itemsToUnload": [ {"itemTypeId": "Type 1", "numberOfItems": "4" }, {"itemTypeId": "Type 3", "numberOfItems": "3"}] }
          ]
      }     
    },
    
    "Stacking restrictions" : {
      "bins": [
        {
          "id": "Truck",
          "numberOfBins": 1,
          "dimensions": {
            "x": 100,
            "y": 100,
            "z": 300
          },
          "maximumWeightCapacity": 25000
        }
      ],
      "items": [
        {
          "id": "Type 1",
          "numberOfItems": 3,
          "dimensions": {
            "x": 30,
            "y": 30,
            "z": 30
          },
          "weight": 50
        },
        {
          "id": "Type 2",
          "numberOfItems": 3,
          "dimensions": {
            "x": 30,
            "y": 30,
            "z": 30
          },
          "weight": 50
        },
        {
          "id": "Type 3",
          "numberOfItems": 3,
          "dimensions": {
            "x": 30,
            "y": 30,
            "z": 30
          },
          "weight": 50
        },
      ],
      "options": {
          "focus": "REDUCE_LOADING_METERS",
          "stackingOptions": {
              "stackingRestrictions": [
                  {"itemTypeId": "Type 1", "restrictionType": "ALL_PROHIBITED"},
                  {"itemTypeId": "Type 2", "restrictionType": "PROHIBITED", "itemTypeIds": ["Type 1", "Type 2"]},
                  {"itemTypeId": "Type 3", "restrictionType": "ALL_PROHIBITED"}
              ]
          }
      }     
    }
};
